<?php
  /* ***** BEGIN LICENSE BLOCK *****
   * Version: MPL 1.1/GPL 2.0/LGPL 2.1
   *
   * The contents of this file are subject to the Mozilla Public License
   * Version 1.1 (the "MPL"); you may not use this file except in
   * compliance with the MPL. You may obtain a copy of the MPL at
   * http://www.mozilla.org/MPL/
   *
   * Software distributed under the MPL is distributed on an "AS IS" basis,
   * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
   * for the specific language governing rights and limitations under the
   * MPL.
   *
   * The Original Code is Xplico Interface (XI).
   *
   * The Initial Developer of the Original Code is
   * Gianluca Costa <g.costa@xplico.org>
   * Portions created by the Initial Developer are Copyright (C) 2007
   * the Initial Developer. All Rights Reserved.
   *
   * Contributor(s):
   *
   * Alternatively, the contents of this file may be used under the terms of
   * either the GNU General Public License Version 2 or later (the "GPL"), or
   * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   * in which case the provisions of the GPL or the LGPL are applicable instead
   * of those above. If you wish to allow use of your version of this file only
   * under the terms of either the GPL or the LGPL, and not to allow others to
   * use your version of this file under the terms of the MPL, indicate your
   * decision by deleting the provisions above and replace them with the notice
   * and other provisions required by the GPL or the LGPL. If you do not delete
   * the provisions above, a recipient may use your version of this file under
   * the terms of any one of the MPL, the GPL or the LGPL.
   *
   * ***** END LICENSE BLOCK ***** */

class PolsController extends AppController {

	var $name = 'Pols';
	var $helpers = array('Html', 'Form' );

        function beforeFilter() {
                $groupid = $this->Session->read('group');
                if (!$groupid) {
                    $this->redirect('/users/login');
                }
                $this->Session->delete('pol');
        }

	function index() {
                $groupid = $this->Session->read('group');
		$this->Pol->recursive = -1;
		$this->set('pols', $this->Pol->findAll("group_id = $groupid", NULL, 'Pol.id DESC'));
                $this->set('menu_left', array(array('label' => 'NewCase', 'link' => '/pols/add')));
	}

	function view($id = null) {
		if(!$id) {
			$this->Session->setFlash('Invalid id for Case.');
			$this->redirect('/pols/index');
		}
                $this->Pol->recursive = 0;
                $pol = $this->Pol->read('group_id', $id);
                if ($pol['Pol']['group_id'] == $this->Session->read('group')) {
                    $this->set('pol', $pol);
                    
                    $this->set('menu_left', array(array('label' => 'Sols', 'link' => '/sols/index')));
                    $this->Session->write('pol', $id);
                    // provvisorio
                    $this->redirect('/sols/index');
                }
                else {
                    $this->redirect('/pols/index');
                }
	}

	function add() {
		if(!empty($this->data)) {
			$this->cleanUpFields();
                        $groupid = $this->Session->read('group');
                        $this->data['Pol']['group_id'] = $groupid;
			if($this->Pol->save($this->data)) {
				$this->Session->setFlash('The Case has been created');
				$this->redirect('/pols/index');
			} else {
				$this->Session->setFlash('Please correct errors below.');
			}
		}
	}

	function delete($id = null) {
		if(!$id) {
			$this->Session->setFlash('Invalid id for Case');
			$this->redirect('/pols/index');
		}
                $pol = $this->Pol->read(null, $id);
                if ($pol['Pol']['group_id'] != $this->Session->read('group')) {
                        $this->Session->setFlash('Invalid id for Case');
			$this->redirect('/pols/index');
                }
		if($this->Pol->del($id)) {
                        // delete directory
                        $pol_dir = '/opt/xplico/pol_'.$id;
                        system('rm -rf '.$pol_dir);
			$this->Session->setFlash('Case deleted');
			$this->redirect('/pols/index');
		}
	}
}
?>