<?php
  /* ***** BEGIN LICENSE BLOCK *****
   * Version: MPL 1.1/GPL 2.0/LGPL 2.1
   *
   * The contents of this file are subject to the Mozilla Public License
   * Version 1.1 (the "MPL"); you may not use this file except in
   * compliance with the MPL. You may obtain a copy of the MPL at
   * http://www.mozilla.org/MPL/
   *
   * Software distributed under the MPL is distributed on an "AS IS" basis,
   * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
   * for the specific language governing rights and limitations under the
   * MPL.
   *
   * The Original Code is Xplico Interface (XI).
   *
   * The Initial Developer of the Original Code is
   * Gianluca Costa <g.costa@xplico.org>
   * Portions created by the Initial Developer are Copyright (C) 2007
   * the Initial Developer. All Rights Reserved.
   *
   * Contributor(s):
   *
   * Alternatively, the contents of this file may be used under the terms of
   * either the GNU General Public License Version 2 or later (the "GPL"), or
   * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   * in which case the provisions of the GPL or the LGPL are applicable instead
   * of those above. If you wish to allow use of your version of this file only
   * under the terms of either the GPL or the LGPL, and not to allow others to
   * use your version of this file under the terms of the MPL, indicate your
   * decision by deleting the provisions above and replace them with the notice
   * and other provisions required by the GPL or the LGPL. If you do not delete
   * the provisions above, a recipient may use your version of this file under
   * the terms of any one of the MPL, the GPL or the LGPL.
   *
   * ***** END LICENSE BLOCK ***** */

class SipsController extends AppController {
        var $name = 'Sips';
        var $helpers = array('Html', 'Form' );

        function beforeFilter() {
                $groupid = $this->Session->read('group');
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                if (!$groupid || !$polid || !$solid) {
                    $this->redirect('/users/login');
                }
        }

        function index() {
                $solid = $this->Session->read('sol');
                $this->Sip->recursive = -1;
                // host selezionato
                $host_id = $this->Session->read('host_id');
                $host_srch = "";
                if (!empty($host_id) && $host_id != 0) {
                    $host_srch = " AND source_id = ".$host_id;
                }
                $this->set('sips', $this->Sip->findAll("sol_id = $solid".$host_srch, NULL, 'Sip.capture_date DESC'));
                $this->set('menu_left', array( array('label' => 'Sols', 'link' => '/sols/index'),
                                               array('label' => 'Session', 'link' => '/sols/view/'.$solid),
                                               array('label' => 'Email', 'link' => '/emails/index'),
                                               array('label' => 'Sip', 'link' => '/sips/index'),
                                               array('label' => 'Web', 'link' => '/webs/index'),
                                               array('label' => 'Feed', 'link' => '/feeds/index'),
                                               array('label' => 'Images', 'link' => '/webs/image'),
                                               array('label' => 'Printer', 'link' => '/pjls/index'),
                                               array('label' => 'Ftp', 'link' => '/ftps/index'),
                                               array('label' => 'Tftp', 'link' => '/tftps/index'),
                                               array('label' => 'Mms', 'link' => '/mms/index'),
                                               array('label' => 'GeoMap', 'link' => '/inputs/geomap'),
                               ));
        }

        function view($id = null) {
                if (!$id) {
                    exit();
                }
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                $this->Sip->recursive = 0;
                $sip = $this->Sip->read(null, $id);
                if ($polid != $sip['Sip']['pol_id'] || $solid != $sip['Sip']['sol_id']) {
                    $this->redirect('/users/login');
                }
                else {
                    // register visualization
                    if (!$sip['Sip']['first_visualization_user_id']) {
                        $uid = $this->Session->read('userid');
                        $sip['Sip']['first_visualization_user_id'] = $uid;
                        $sip['Sip']['viewed_date'] = date("Y-m-d H:i:s");
                        $this->Sip->save($sip);
                    }
                    $this->autoRender = false;
                    header("Content-Disposition: filename=av".$id.".sdp");
                    header("Content-Type: text/html; charset=utf-8");
                    header("Content-Length: " . filesize('/opt/xplico/script/av.sdp'));
                    readfile('/opt/xplico/script/av.sdp');
                    exit();
                }
        }

        function info($id = null) {
                if (!$id) {
                    exit();
                }
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                $sip = $this->Sip->read(null, $id);
                if ($polid != $sip['Sip']['pol_id'] || $solid != $sip['Sip']['sol_id']) {
                    $this->redirect('/users/login');
                }
                else {
                    $this->autoRender = false;
                    header("Content-Disposition: filename=info".$id.".xml");
                    header("Content-Type: application/xhtml+xml; charset=utf-8");
                    header("Content-Length: " . filesize($sip['Sip']['flow_info']));
                    readfile($sip['Sip']['flow_info']);
                    exit();
                }
        }
}
?>
