<?php
  /* ***** BEGIN LICENSE BLOCK *****
   * Version: MPL 1.1/GPL 2.0/LGPL 2.1
   *
   * The contents of this file are subject to the Mozilla Public License
   * Version 1.1 (the "MPL"); you may not use this file except in
   * compliance with the MPL. You may obtain a copy of the MPL at
   * http://www.mozilla.org/MPL/
   *
   * Software distributed under the MPL is distributed on an "AS IS" basis,
   * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
   * for the specific language governing rights and limitations under the
   * MPL.
   *
   * The Original Code is Xplico Interface (XI).
   *
   * The Initial Developer of the Original Code is
   * Gianluca Costa <g.costa@xplico.org>
   * Portions created by the Initial Developer are Copyright (C) 2007
   * the Initial Developer. All Rights Reserved.
   *
   * Contributor(s):
   *
   * Alternatively, the contents of this file may be used under the terms of
   * either the GNU General Public License Version 2 or later (the "GPL"), or
   * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   * in which case the provisions of the GPL or the LGPL are applicable instead
   * of those above. If you wish to allow use of your version of this file only
   * under the terms of either the GPL or the LGPL, and not to allow others to
   * use your version of this file under the terms of the MPL, indicate your
   * decision by deleting the provisions above and replace them with the notice
   * and other provisions required by the GPL or the LGPL. If you do not delete
   * the provisions above, a recipient may use your version of this file under
   * the terms of any one of the MPL, the GPL or the LGPL.
   *
   * ***** END LICENSE BLOCK ***** */

class SolsController extends AppController {

        var $name = 'Sols';
        var $helpers = array('Html', 'Form' );
        var $uses = array('Sol', 'Source', 'Email', 'Web', 'Ftp', 'Ftp_file', 'Sip', 'Mm', 'Mmscontent', 'Pjl', 'Feed', 'Tftp', 'Tftp_file');
        function beforeFilter() {
                $groupid = $this->Session->read('group');
                $polid = $this->Session->read('pol');
                if (!$groupid || !$polid) {
                    $this->Session->delete('sol');
                    $this->Session->delete('host_id');
                    $this->redirect('/users/login');
                }
        }

        function index() {
                $polid = $this->Session->read('pol');
                $this->Session->delete('host_id');
                $this->Sol->recursive = -1;
                $sols = $this->Sol->findAll("pol_id = $polid", NULL, 'Sol.id DESC');
                $this->set('sols', $sols);
                $this->set('menu_left', array(array('label' => 'New SoL', 'link' => '/sols/add')));
                if (!empty($sols['0']['Sol']['id']))
                    $this->Session->write('last_sol_id', $sols['0']['Sol']['id']);
        }

        function view($id = null) {
                if (!$id) {
	    		    $this->Session->setFlash('Invalid id for Session.');
	    		    $this->redirect('/sols/index');
                }
                $this->Sol->recursive = 0;
                $sol = $this->Sol->read(null, $id);
                if ($sol['Sol']['pol_id'] == $this->Session->read('pol')) {
                    // host selezionato
                    $host_id = $this->Session->read('host_id');
                    $host_srch = "";
                    if (!empty($host_id) && $host_id != 0) {
                        $host_srch = " AND source_id = ".$host_id;
                        $this->set('host', $host_id);
                    }
                    else {
                        $this->set('host', 0);
                    }
                    // lista degli host
                    $this->Source->recursive = -1;
                    //$this->set('host_data', $this->Source->findAll("sol_id = $id"));
                    $this->set('hosts', $this->Source->generateList( "sol_id = $id", "ip ASC", null, "{n}.Source.id", "{n}.Source.ip")
                        );
                    
                    // calcolo delle email
                    $eml_received =  $this->Email->findCount("sol_id = $id AND receive = 1".$host_srch, -1);
                    $eml_total = $this->Email->findCount("sol_id = $id".$host_srch, -1);
                    $eml_sended = $eml_total - $eml_received;
                    $eml_unread =  $eml_total - $this->Email->findCount("sol_id = $id AND first_visualization_user_id != 0".$host_srch, -1);
                    $this->set('eml_received', $eml_received);
                    $this->set('eml_sended', $eml_sended);
                    $this->set('eml_unread', $eml_unread);
                    $this->set('eml_total', $eml_total);
                    // web
                    $web_post = $this->Web->findCount("sol_id = $id AND method = 'POST'".$host_srch, -1);
                    $web_get = $this->Web->findCount("sol_id = $id AND method = 'GET'".$host_srch, -1);
                    $web_video = $this->Web->findCount("sol_id = $id AND content_type LIKE '%video%'".$host_srch, -1);
                    $web_image = $this->Web->findCount("sol_id = $id AND content_type LIKE '%image%'".$host_srch, -1);
                    $this->set('web_post', $web_post);
                    $this->set('web_get', $web_get);
                    $this->set('web_video', $web_video);
                    $this->set('web_image', $web_image);
                    // ftp
                    $ftp_num = $this->Ftp->findCount("sol_id = $id".$host_srch, -1);
                    $ftp_down = $this->Ftp_file->findCount("sol_id = $id AND dowloaded = 1".$host_srch, -1);
                    $ftp_up = $this->Ftp_file->findCount("sol_id = $id".$host_srch, -1) - $ftp_down;
                    $this->set('ftp_num', $ftp_num);
                    $this->set('ftp_down', $ftp_down);
                    $this->set('ftp_up', $ftp_up);
                    // mms
                    $mms_num = $this->Mm->findCount("sol_id = $id".$host_srch, -1);
                    $mms_cont = $this->Mmscontent->findCount("sol_id = $id".$host_srch, -1) - $mms_num;
                    $mms_video = $this->Mmscontent->findCount("sol_id = $id AND content_type LIKE '%video%'".$host_srch, -1);
                    $mms_image = $this->Mmscontent->findCount("sol_id = $id AND content_type LIKE '%image%'".$host_srch, -1);
                    $this->set('mms_num', $mms_num);
                    $this->set('mms_cont', $mms_cont);
                    $this->set('mms_video', $mms_video);
                    $this->set('mms_image', $mms_image);
                    // pjl
                    $pjl_num = $this->Pjl->findCount("sol_id = $id".$host_srch, -1);
                    $this->set('pjl_num', $pjl_num);
                    // feed
                    $feed_num = $this->Feed->findCount("sol_id = $id".$host_srch, -1);
                    $this->set('feed_num', $feed_num);                    
                    // tftp
                    $tftp_num = $this->Tftp->findCount("sol_id = $id".$host_srch, -1);
                    $tftp_down = $this->Tftp_file->findCount("sol_id = $id AND dowloaded = 1".$host_srch, -1);
                    $tftp_up = $this->Tftp_file->findCount("sol_id = $id".$host_srch, -1) - $tftp_down;
                    $this->set('tftp_num', $tftp_num);
                    $this->set('tftp_down', $tftp_down);
                    $this->set('tftp_up', $tftp_up);
                    // sip
                    $this->set('sip_calls', 0); // g.costa@xplico.org
                    // rtp
                    $this->set('rtp_video', 0);
                    $this->set('rtp_audio', 0);

                    //$this->set('', $);
                    // menu
                    $last_sol_id = $this->Session->read('last_sol_id');
                    if ($last_sol_id == $id)
                        $this->set('last_sol', 1);
                    else
                        $this->set('last_sol', 0);
                    $this->set('sol', $sol);
                    $this->set('menu_left', array( array('label' => 'Sols', 'link' => '/sols/index'),
                                                   array('label' => 'Session', 'link' => '/sols/view/'.$id),
                                                   array('label' => 'Email', 'link' => '/emails/index'),
                                                   array('label' => 'Sip', 'link' => '/sips/index'),
                                                   array('label' => 'Web', 'link' => '/webs/index'),
                                                   array('label' => 'Feed', 'link' => '/feeds/index'),
                                                   array('label' => 'Images', 'link' => '/webs/image'),
                                                   array('label' => 'Printer', 'link' => '/pjls/index'),
                                                   array('label' => 'Ftp', 'link' => '/ftps/index'),
                                                   array('label' => 'Tftp', 'link' => '/tftps/index'),
                                                   array('label' => 'Mms', 'link' => '/mms/index'),
                                                   array('label' => 'GeoMap', 'link' => '/inputs/geomap'),
                                   ));
                    $this->set('refresh_time', 30);
                    $this->Session->write('sol', $id);
                }
                else {
                    $this->redirect('/pols/index');
                }
        }

        function add() {
            if (empty($this->data)) {
                $this->render();
            } else {
                $this->cleanUpFields();
                $polid = $this->Session->read('pol');
                $this->data['Sol']['pol_id'] = $polid;
                if($this->Sol->save($this->data)) {
                                $this->Session->setFlash('The Session has been created');
				$this->redirect('/sols/index');
                                system('cd /opt/xplico; /opt/xplico/script/create_session.sh '. $polid . ' ' . $this->Sol->getLastInsertId());
			    } else {
                    $this->Session->setFlash('Please correct errors below.');
			    }
		    }
        }

        function delete($id = null) {
            if (!$id) {
                $this->Session->setFlash('Invalid id for Session');
                $this->redirect('/sols/index');
            } 
                $sol = $this->Sol->read(null, $id);
                if ($sol['Sol']['pol_id'] != $this->Session->read('pol')) {
                        $this->Session->setFlash('Invalid id for Session');
			$this->redirect('/sols/index');
                }
		if ($this->Sol->del($id)) {
                        // delete directory
                        $sol_dir = '/opt/xplico/pol_'.$this->Session->read('pol').'/sol_'.$id;
                        system('rm -rf '.$sol_dir);
			$this->Session->setFlash('Session deleted');
			$this->redirect('/sols/index');
		}
	}

        function pcap() {
            if (!empty($this->params['form']) &&
                is_uploaded_file($this->params['form']['File']['tmp_name'])) {
                $filedec = '/opt/xplico/pol_'.$this->Session->read('pol').'/sol_'.$this->Session->read('sol').'/new/'.$this->params['form']['File']['name'];
                move_uploaded_file($this->params['form']['File']['tmp_name'], $filedec);
                $this->Session->setFlash('File uploaded, wait start decoding...');
                $this->redirect('/sols/view/'.$this->Session->read('sol'));
            }
            else {
                $this->Session->setFlash('Upload Failed');
                $this->redirect('/sols/index');
            }
        }

        function host() {
            $this->Session->write('host_id', $this->data['sols']['host']);
            $sol = $this->Session->read('sol');
            $this->redirect('/sols/view/'.$sol);
        }
}
?>
