<?php
  /* ***** BEGIN LICENSE BLOCK *****
   * Version: MPL 1.1/GPL 2.0/LGPL 2.1
   *
   * The contents of this file are subject to the Mozilla Public License
   * Version 1.1 (the "MPL"); you may not use this file except in
   * compliance with the MPL. You may obtain a copy of the MPL at
   * http://www.mozilla.org/MPL/
   *
   * Software distributed under the MPL is distributed on an "AS IS" basis,
   * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the MPL
   * for the specific language governing rights and limitations under the
   * MPL.
   *
   * The Original Code is Xplico Interface (XI).
   *
   * The Initial Developer of the Original Code is
   * Gianluca Costa <g.costa@xplico.org>
   * Portions created by the Initial Developer are Copyright (C) 2007
   * the Initial Developer. All Rights Reserved.
   *
   * Contributor(s):
   *
   * Alternatively, the contents of this file may be used under the terms of
   * either the GNU General Public License Version 2 or later (the "GPL"), or
   * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   * in which case the provisions of the GPL or the LGPL are applicable instead
   * of those above. If you wish to allow use of your version of this file only
   * under the terms of either the GPL or the LGPL, and not to allow others to
   * use your version of this file under the terms of the MPL, indicate your
   * decision by deleting the provisions above and replace them with the notice
   * and other provisions required by the GPL or the LGPL. If you do not delete
   * the provisions above, a recipient may use your version of this file under
   * the terms of any one of the MPL, the GPL or the LGPL.
   *
   * ***** END LICENSE BLOCK ***** */

uses('sanitize');

class TftpsController extends AppController {

        var $name = 'Tftps';
        var $uses = array('Tftp', 'Tftp_file');
        var $helpers = array('Html', 'Form' );
        var $components = array('Xml2Pcap');

        function beforeFilter() {
                $groupid = $this->Session->read('group');
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                if (!$groupid || !$polid || !$solid) {
                    $this->redirect('/users/login');
                }
        }

        function index($id = null) {
                $lines = 16;
                $solid = $this->Session->read('sol');
                $this->Tftp->recursive = -1;
                // host selezionato
                $host_id = $this->Session->read('host_id');
                $host_srch = "";
                if (!empty($host_id) && $host_id != 0) {
                    $host_srch = " AND source_id = ".$host_id;
                }
                if ($id === null) {
                    $srchd = array();
                    $srch = null;
                    $page = 1;
                }
                else {
                    $page = $this->Session->read('page');
                    $srch = $this->Session->read('srch');
                    $srchd = array('value' => $srch);
                    if ($id == 1) {
                        $page++;
                    }
                    else {
                        $page--;
                    }
                }
                $prev = 0;
                $next = 0;
                if ($this->data) {
                    $srch = $this->data['Search']['label'];
                }
                if (!empty($srch)) {
                    $this->set('tftps', $this->Tftp->findAll("sol_id = $solid AND (url LIKE '%$srch%')".$host_srch, NULL, 'Tftp.capture_date DESC', $lines, $page));
                    $total = $this->Tftp->findCount("sol_id = $solid AND (url LIKE '%$srch%')".$host_srch, -1);
                }
                else {
                    $this->set('tftps', $this->Tftp->findAll("sol_id = $solid".$host_srch, NULL, 'Tftp.capture_date DESC', $lines, $page));
                    $total = $this->Tftp->findCount("sol_id = $solid".$host_srch, -1);
                }
                if ($total) {
                    $prev = $page - 1;
                    $next = ((int)(($total+$lines-1)/$lines))-$page;
                }
                $this->Session->write('page', $page);
                $this->Session->write('srch', $srch);
                $this->set('prev', $prev);
                $this->set('total', $total);
                $this->set('next', $next);
                $this->set('srchd', $srchd);
                $this->set('menu_left', array( array('label' => 'Sols', 'link' => '/sols/index'),
                                               array('label' => 'Session', 'link' => '/sols/view/'.$solid),
                                               array('label' => 'Email', 'link' => '/emails/index'),
                                               array('label' => 'Sip', 'link' => '/sips/index'),
                                               array('label' => 'Web', 'link' => '/webs/index'),
                                               array('label' => 'Feed', 'link' => '/feeds/index'),
                                               array('label' => 'Images', 'link' => '/webs/image'),
                                               array('label' => 'Printer', 'link' => '/pjls/index'),
                                               array('label' => 'Ftp', 'link' => '/ftps/index'),
                                               array('label' => 'Tftp', 'link' => '/tftps/index'),
                                               array('label' => 'Mms', 'link' => '/mms/index'),
                                               array('label' => 'GeoMap', 'link' => '/inputs/geomap'),
                               ));
        }

        function view($id = null) {
                if (!$id) {
                    exit();
                }
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                $this->set('menu_left', array( array('label' => 'Sols', 'link' => '/sols/index'),
                                               array('label' => 'Session', 'link' => '/sols/view/'.$solid),
                                               array('label' => 'Email', 'link' => '/emails/index'),
                                               array('label' => 'Sip', 'link' => '/sips/index'),
                                               array('label' => 'Web', 'link' => '/webs/index'),
                                               array('label' => 'Feed', 'link' => '/feeds/index'),
                                               array('label' => 'Images', 'link' => '/webs/image'),
                                               array('label' => 'Printer', 'link' => '/pjls/index'),
                                               array('label' => 'Ftp', 'link' => '/ftps/index'),
                                               array('label' => 'Tftp', 'link' => '/tftps/index'),
                                               array('label' => 'Mms', 'link' => '/mms/index'),
                                               array('label' => 'GeoMap', 'link' => '/inputs/geomap'),
                               ));
                $this->Tftp->recursive = -1;
                $tftp = $this->Tftp->read(null, $id);
                if ($polid != $tftp['Tftp']['pol_id'] || $solid != $tftp['Tftp']['sol_id']) {
                    $this->redirect('/users/login');
                }
                //print_r($tftp);
                $this->Session->write('tftpid', $id);
                $this->set('tftp', $tftp);

                /* files */
                $this->Tftp_file->recursive = -1;
                //$this->set('tftp_file', $this->Tftp_file->findAll("sol_id = $solid AND tftp_id = $id AND file_size != 0", NULL, 'Tftp_file.capture_date DESC'));
                $this->set('tftp_file', $this->Tftp_file->findAll("sol_id = $solid AND tftp_id = $id", NULL, 'Tftp_file.capture_date DESC'));
                // register visualization
                if (!$tftp['Tftp']['first_visualization_user_id']) {
                    $uid = $this->Session->read('userid');
                    $tftp['Tftp']['first_visualization_user_id'] = $uid;
                    $tftp['Tftp']['viewed_date'] = date("Y-m-d H:i:s");
                    $this->Tftp->save($tftp);
                }
        }

        function cmd() {
            $id = $this->Session->read('tftpid');
            if (!$id) {
                $this->redirect('/users/login');
            }
            else {
                $tftp = $this->Tftp->read(null, $id);
                $this->autoRender = false;
                header("Content-Disposition: filename=tftp_cmd".$id.".txt");
                header("Content-Type: text");
                header("Content-Length: " . filesize($tftp['Tftp']['cmd_path']));
                readfile($tftp['Tftp']['cmd_path']);
                exit();
            }
        }

        function info() {
            $id = $this->Session->read('tftpid');
            if (!$id) {
                $this->redirect('/users/login');
            }
            else {
                $this->Tftp->recursive = -1;
                $tftp = $this->Tftp->read(null, $id);
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                if ($polid != $tftp['Tftp']['pol_id'] || $solid != $tftp['Tftp']['sol_id']) {
                    $this->redirect('/users/login');
                }
                $this->autoRender = false;
                header("Content-Disposition: filename=info".$id.".xml");
                header("Content-Type: application/xhtml+xml; charset=utf-8");
                header("Content-Length: " . filesize($tftp['Tftp']['flow_info']));
                readfile($tftp['Tftp']['flow_info']);
                exit();
            }
        }

        function info_data($id_data = null) {
            $id = $this->Session->read('tftpid');
            if (!$id || !$id_data) {
                die();
            }
            else {
                $this->Tftp_file->recursive = -1;
                $tftp_file = $this->Tftp_file->read(null, $id_data);
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                if ($polid != $tftp_file['Tftp_file']['pol_id'] || $solid != $tftp_file['Tftp_file']['sol_id']) {
                    die();
                }
                $this->autoRender = false;
                header("Content-Disposition: filename=info_data".$id_data.".xml");
                header("Content-Type: application/xhtml+xml; charset=utf-8");
                header("Content-Length: " . filesize($tftp_file['Tftp_file']['flow_info']));
                readfile($tftp_file['Tftp_file']['flow_info']);
                exit();
            }
        }

        function data_file($id_data = null) {
            $id = $this->Session->read('tftpid');
            if (!$id || !$id_data) {
                $this->redirect('/users/login');
            }
            else {
                $this->Tftp_file->recursive = -1;
                $tftp_data = $this->Tftp_file->read(null, $id_data);
                $polid = $this->Session->read('pol');
                $solid = $this->Session->read('sol');
                if ($polid != $tftp_data['Tftp_file']['pol_id'] || $solid != $tftp_data['Tftp_file']['sol_id']) {
                    die();
                }
                $this->autoRender = false;
                header("Content-Disposition: filename=" . $tftp_data['Tftp_file']['filename']);
                header("Content-Type: bin");
                header("Content-Length: " . filesize($tftp_data['Tftp_file']['file_path']));
                readfile($tftp_data['Tftp_file']['file_path']);
                //print_r($tftp_data);
                exit();
            }
        }

        function pcap($id = null) {
            $polid = $this->Session->read('pol');
            $solid = $this->Session->read('sol');
            if (!$id) {
                $id = $this->Session->read('tftpid');
                if (!$id)
                    die();
                $this->Tftp->recursive = -1;
                $tftp = $this->Tftp->read(null, $id);
                if ($polid != $tftp['Tftp']['pol_id'] || $solid != $tftp['Tftp']['sol_id']) {
                    die();
                }
                $flow_info = $tftp['Tftp']['flow_info'];
            }
            else {
                $this->Tftp_file->recursive = -1;
                $tftp_file = $this->Tftp_file->read(null, $id);
                if ($polid != $tftp_file['Tftp_file']['pol_id'] || $solid != $tftp_file['Tftp_file']['sol_id']) {
                    die();
                }
                $flow_info = $tftp_file['Tftp_file']['flow_info'];
            }
            $file_pcap = "/tmp/tftp_".time()."_".$id.".pcap";
            $this->Xml2Pcap->doPcap($file_pcap, $flow_info);
            $this->autoRender = false;
            header("Content-Disposition: filename=tftp_".$id.".pcap");
            header("Content-Type: binary");
            header("Content-Length: " . filesize($file_pcap));
            @readfile($file_pcap);
            unlink($file_pcap);
            exit();
       }
}
?>
